\name{rareMETALS.single}
\alias{rareMETALS.single}

\title{
Single variant meta-analysis using RARE-METALS method. 
}
\description{
  This function implements single variant association test, which
  combines score statistics across different studies via
  Cochran-Mantel-Haenszel method. 
}
\usage{
rareMETALS.single(score.stat.file, cov.file, range, alternative = c("two.sided", "greater", "less"), ix.gold = 1, callrate.cutoff = 0, hwe.cutoff = 0)
}

\arguments{
  \item{score.stat.file}{
    Vector of file names of single variant score statistics in each study.
}
  \item{cov.file}{
    Vector fo file names of variance-covariance matrix between single
    variant score statistics in each study. 
  }
  \item{range}{
    Range of genomic intervals to be analyzed. The format for range is
    compatible with tabix format. An exemplar range can be 1:12345-1234567.
  }
  \item{alternative}{
    Alternative hypothesis to be tested. Options include two.sided,
    greater and less. 
  }
  \item{ix.gold}{Gold standard population. Since there may be
    incompatible allele labels between different studies, it may be
    helpful to specify a gold standard population, with which allele
    labels can be compared and corrected correspondingly.  } 
  \item{callrate.cutoff}{The default value is set for callrate is
    0.9. Variant sites with call rate below 0.9 is automatically labeled
    as NA.}
  \item{hwe.cutoff}{The default value for Hardy Weinberg p-value cutoff
  is 1e-7. Sites with extreme HWE p-values are labeled as NA.}
  
}
\details{

}
\value{
}
\references{
Liu DJ et al Meta-analysis of Gene-level Association Test, submitted, 2013
}
\author{
Dajiang J. Liu
}
\note{

}

\seealso{

}
\examples{

}
